%define lib              libffmpeg
%define majoravcodec     54
%define libavcodec       libavcodec
%define libnameavcodec   %{libavcodec}%{majoravcodec}
%define majoravdevice    54
%define libavdevice      libavdevice
%define libnameavdevice  %{libavdevice}%{majoravdevice}
%define majoravformat    54
%define libavformat      libavformat
%define libnameavformat  %{libavformat}%{majoravformat}
%define majoravutil      51
%define libavutil        libavutil
%define libnameavutil    %{libavutil}%{majoravutil}
%define majoravfilter    3
%define libavfilter      libavfilter
%define libnameavfilter  %{libavfilter}%{majoravfilter}
%define majorpostproc    52
%define libpostproc      libpostproc
%define libnamepostproc  %{libpostproc}%{majorpostproc}
%define majorswscale     2
%define libswscale       libswscale
%define libnameswscale   %{libswscale}%{majorswscale}
%define majorswresample  0
%define libswresample    libswresample
%define libnameswresample %{libswresample}%{majorswresample}
%define majoravresample  0
%define libavresample    libavresample
%define libnameavresample %{libavresample}%{majoravresample}
%define lastrelease      1.0.6

%bcond_without avfilter
%bcond_without libvpx
%bcond_with    libfaac
%bcond_with    libopenjpeg
%if 0%{?suse_version} >= 1140
%bcond_without pulse
%else
%bcond_with    pulse
%endif

Name:           ffmpeg
Version:        %{lastrelease}
Release:        1.1
License:        LGPL-2.0+ and some code GPL-2.0+
Summary:        Hyper fast MPEG1/MPEG4/H263/RV and AC3/MPEG audio encoder
Summary(de):    Hyperschneller MPEG1/MPEG4/H263/RV Und AC3/MPEG Audio-Encoder
Url:            http://www.ffmpeg.org
Group:          Productivity/Multimedia/Video/Editors and Convertors
Source0:        ffmpeg-%{version}.tar.bz2
Source1:        ffmpeg.rpmlintrc
Source2:        baselibs.conf
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Provides:       libav                = %{version}
Obsoletes:      libav                < %{version}
BuildRequires:  SDL-devel
BuildRequires:  alsa-devel
BuildRequires:  freetype2-devel
BuildRequires:  imlib2-devel
BuildRequires:  libgsm
BuildRequires:  libgsm-devel
BuildRequires:  libjack-devel
BuildRequires:  libmp3lame-devel
BuildRequires:  libogg-devel
BuildRequires:  libtheora-devel >= 1.1
BuildRequires:  libvorbis-devel
BuildRequires:  ncurses-devel
BuildRequires:  slang-devel
BuildRequires:  xorg-x11-devel
BuildRequires:  yasm
BuildRequires:  zlib-devel
%if %{with pulse}
BuildRequires:  libpulse-devel
%endif
%if %{with libfaac}
BuildRequires:  libfaac-devel >= 1.28
%endif
BuildRequires:  libdc1394
BuildRequires:  libdc1394-devel
BuildRequires:  liboil-devel >= 0.3.15
BuildRequires:  libopencore-amr-devel
BuildRequires:  librtmp-devel
BuildRequires:  libva-devel
BuildRequires:  libx264-devel
BuildRequires:  libxvidcore-devel
BuildRequires:  schroedinger-devel
BuildRequires:  speex-devel
BuildRequires:  libtwolame-devel
BuildRequires:  texinfo
%if 0%{?suse_version} <= 1130
BuildRequires:  libdc1394_control12-devel
%endif
%if 0%{?suse_version} >= 1140
BuildRequires:  libass-devel
BuildRequires:  libopus-devel
%else
BuildRequires:  libass-devel
BuildRequires:  fontconfig-devel >= 2.4.2
BuildRequires:  enca-devel
BuildRequires:  fribidi-devel >= 0.19.0
%endif
%if %{with libopenjpeg}
BuildRequires:  libopenjpeg-devel
%endif
BuildRequires:  libvdpau-devel
%if %{with libvpx}
%ifarch %ix86 x86_64 amd64 ia32e
BuildRequires:  libvpx-devel
%endif
%endif
BuildRequires:  pkgconfig(vo-aacenc)
Requires:       %{libnameavcodec}    = %{version}
Requires:       %{libnameavdevice}   = %{version}
Requires:       %{libnameavformat}   = %{version}
Requires:       %{libnameavutil}     = %{version}
Requires:       %{libnamepostproc}   = %{version}
Requires:       %{libnameswscale}    = %{version}
Requires:       %{libnameswresample} = %{version}
Requires:       %{libnameavresample} = %{version}

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

%description -l de
ffmpeg ist ein hyperschneller realtime Audio-/Video-Encoder, ein Streaming
Server und ein Audio und Video Dateikonverter.

Es kann von einer Standard-Video4Linux-Quelle grabben und in verschiedene
Dateiformate basierend auf einer DCT/motion compensation konvertiern.
Sound wird in einen MPEG audio layer 2 oder AC3 Stream geschrieben.

%package -n %{libnameavcodec}
Group:          System/Libraries
Summary:        FFmpeg %{libavcodec}
Provides:       %{libavcodec}        = %{version}
Requires:       %{libnameavutil}     = %{version}

%description -n %{libnameavcodec}
ffmpeg %{libavcodec} shared library

%description -n %{libnameavcodec} -l de
ffmpeg %{libavcodec} Bibliothek

%package -n %{libnameavdevice}
Group:          System/Libraries
Summary:        FFmpeg %{libavdevice}
Provides:       %{libavdevice}       = %{version}
Requires:       %{libnameavcodec}    = %{version}
Requires:       %{libnameavformat}   = %{version}
Requires:       %{libnameavutil}     = %{version}
Requires:       %{libnameswresample} = %{version}

%description -n %{libnameavdevice}
ffmpeg %{libavdevice} shared library

%description -n %{libnameavdevice} -l de
ffmpeg %{libavdevice} Bibliothek

%package -n %{libnameavformat}
Group:          System/Libraries
Summary:        FFmpeg %{libavformat}
Provides:       %{libavformat}       = %{version}
Requires:       %{libnameavcodec}    = %{version}
Requires:       %{libnameavutil}     = %{version}
%if %{with avfilter}
Requires:       %{libnameavfilter}   = %{version}
%endif

%description -n %{libnameavformat}
ffmpeg %{libavformat} shared library

%description -n %{libnameavformat} -l de
ffmpeg %{libavformat} Bibliothek

%package -n %{libnameavutil}
Group:          System/Libraries
Summary:        FFmpeg %{libavutil}
Provides:       %{libavutil}         = %{version}

%description -n %{libnameavutil}
ffmpeg %{libavutil} shared library

%description -n %{libnameavutil} -l de
ffmpeg %{libavutil} Bibliothek

%package -n %{libnameavfilter}
Group:          System/Libraries
Summary:        FFmpeg %{libavutil}
Provides:       %{libavfilter}       = %{version}
Requires:       %{libnameavcodec}    = %{version}
Requires:       %{libnameavutil}     = %{version}
Requires:       %{libnameswscale}    = %{version}
Requires:       %{libnameswresample} = %{version}

%description -n %{libnameavfilter}
ffmpeg %{libavfilter} shared library

%description -n %{libnameavfilter} -l de
ffmpeg %{libavfilter} Bibliothek

%package -n %{libnamepostproc}
Group:          System/Libraries
Summary:        FFmpeg %{libpostproc}
Provides:       %{libpostproc}       = %{version}
Requires:       %{libnameavutil}     = %{version}

%description -n %{libnamepostproc}
ffmpeg %{libpostproc} shared library

%description -n %{libnamepostproc} -l de
ffmpeg %{libpostproc} Bibliothek

%package -n %{libnameswscale}
Group:          System/Libraries
Summary:        FFmpeg %{libswscale}
Provides:       %{libswscale}        = %{version}
Requires:       %{libnameavutil}     = %{version}

%description -n %{libnameswscale}
ffmpeg %{libswscale} shared library

%description -n %{libnameswscale} -l de
ffmpeg %{libswscale} Bibliothek

%package -n %{libnameswresample}
Group:          System/Libraries
Summary:        FFmpeg %{libswresample}
Provides:       %{libswresample}     = %{version}
Requires:       %{libnameavutil}     = %{version}

%description -n %{libnameswresample}
ffmpeg %{libswresample} shared library

%description -n %{libnameswresample} -l de
ffmpeg %{libswresample} Bibliothek


%package -n %{libnameavresample}
Group:          System/Libraries
Summary:        FFmpeg %{libavresample}
Provides:       %{libavresample}     = %{version}

%description -n %{libnameavresample}
ffmpeg %{libavresample} shared library

%description -n %{libnameavresample} -l de
ffmpeg %{libavresample} Bibliothek


%package -n %{lib}-devel
Group:          Development/Libraries/C and C++
Summary:        Header files and static library for the ffmpeg library
Summary(de):    Header Dateien und statische Bibliotheken für die ffmpeg Bibliothek
Obsoletes:      ffmpeg-devel         < %{version}
Provides:       ffmpeg-devel         = %{version}
Obsoletes:      libffmpeg0-devel     < %{version}
Provides:       libffmpeg0-devel     = %{version}
Obsoletes:      libav-devel          < %{version}
Provides:       libav-devel          = %{version}
Obsoletes:      libavutil-devel      < %{version}
Provides:       libavutil-devel      = %{version}
%ifarch x86_64 amd64 ia32e
Provides:       libavcodec.so()(64bit)
Provides:       libavformat.so()(64bit)
Provides:       libavutil.so()(64bit)
%if %{with avfilter}
Provides:       libavfilter.so()(64bit)
%endif
Provides:       libpostproc.so()(64bit)
%else
Provides:       libavcodec.so
Provides:       libavformat.so
Provides:       libavutil.so
%if %{with avfilter}
Provides:       libavfilter.so
%endif
Provides:       libpostproc.so
%endif
Requires:       %{libnameavcodec}    = %{version}
Requires:       %{libnameavdevice}   = %{version}
Requires:       %{libnameavformat}   = %{version}
Requires:       %{libnameavutil}     = %{version}
Requires:       %{libnamepostproc}   = %{version}
%if %{with avfilter}
Requires:       %{libnameavfilter}   = %{version}
%endif
Requires:       %{libnameswscale}    = %{version}
Requires:       %{libnameswresample} = %{version}
Requires:       %{libnameavresample} = %{version}
Requires:       alsa-devel
Requires:       libmp3lame-devel
Requires:       libogg-devel
Requires:       libtheora-devel >= 1.1
Requires:       libvorbis-devel
Requires:       libxvidcore-devel
Requires:       slang-devel
Requires:       zlib-devel
%if %{with libfaac}
Requires:       libfaac-devel
%endif
Requires:       dirac-devel >= 1.0.0
Requires:       libdc1394
Requires:       libdc1394-devel
Requires:       libgsm-devel
Requires:       libjack-devel
Requires:       liboil-devel >= 0.3.15
Requires:       libopencore-amr-devel
Requires:       librtmp-devel
Requires:       libva-devel
Requires:       libx264-devel
Requires:       schroedinger-devel
Requires:       speex-devel
%if 0%{?suse_version} <= 1130
Requires:       libdc1394_control12-devel
%endif
%if %{with libopenjpeg}
Requires:       libopenjpeg-devel
%endif
Requires:       libvdpau-devel

%description -n %{lib}-devel
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%description -n %{lib}-devel -l de
ffmpeg ist ein hyperschneller realtime Audio-/Video-Encoder, ein Streaming
Server und ein Audio und Video Dateikonverter.

Es kann von einer Standard-Video4Linux-Quelle grabben und in verschiedene
Dateiformate basierend auf einer DCT/motion compensation konvertiern.
Sound wird in einen MPEG audio layer 2 oder AC3 Stream geschrieben.

Installieren Sie libffmpeg-devel wenn Sie Anwendungen mit ffmpeg Support
compilieren wollen.

%prep
%setup -q
FAKE_BUILDDATE=$(LC_ALL=C date -u -r %{_sourcedir}/%{name}.changes '+%%b %%e %%Y')
sed -i "s/__DATE__/\"$FAKE_BUILDDATE\"/" cmdutils.c ffprobe.c
FAKE_BUILDTIME=$(LC_ALL=C date -u -r %{_sourcedir}/%{name}.changes '+%%H:%%M:%%S')
sed -i "s/__TIME__/\"$FAKE_BUILDTIME\"/" cmdutils.c ffprobe.c

%build
export SUSE_ASNEEDED=0
archflags=""
%ifarch x86_64 amd64 ia32e
  archflags=" -fPIC"
%endif
%ifarch %ix86
  archflags=" -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
  sed -i -e "s/-fPIC -DPIC//g" libpostproc/Makefile
%endif

CFLAGS="%{optflags} ${archflags} -I%{_includedir}/gsm"
%if %{with libopenjpeg}
CFLAGS="${CFLAGS}  -I%{_includedir}/openjpeg"
%endif
export archflags
export CFLAGS
CPPFLAGS="${CFLAGS}"
export CPPFLAGS

./configure --shlibdir=%{_libdir} --prefix=%{_prefix} --mandir=%{_mandir} \
            --libdir=%{_libdir} --enable-shared --disable-static \
            --enable-debug --disable-stripping --extra-cflags="${CFLAGS}" \
            --enable-gpl --enable-x11grab --enable-version3 --enable-pthreads \
%ifarch ppc
            --disable-altivec \
%endif
%if %{with libfaac}
            --enable-libfaac --enable-nonfree \
%endif
%if %{with libopenjpeg}
            --enable-libopenjpeg \
%endif
%if %{with avfilter}
            --enable-avfilter \
%else
            --disable-avfilter \
%endif
%if %{with pulse}
            --enable-libpulse \
%endif
%if %{with libvpx}
%ifarch %ix86 x86_64 amd64 ia32e
            --enable-libvpx \
%endif
%endif
%if 0%{?suse_version} >= 1140
            --enable-libopus --enable-libass \
%else
            --enable-libass \
%endif
            --enable-libmp3lame --enable-libvorbis --enable-libtheora \
            --enable-libspeex --enable-libxvid --enable-libx264 \
            --enable-libschroedinger --enable-libgsm \
            --enable-libopencore-amrnb --enable-libopencore-amrwb \
            --enable-postproc --enable-libdc1394 --enable-librtmp \
            --enable-libfreetype --enable-avresample --enable-libtwolame \
            --enable-libvo-aacenc

make %{?_smp_mflags} V=1

%install
ln -s libavformat libav
%{makeinstall} V=1

mkdir -p %{buildroot}%{_includedir}/postproc
install -d %{buildroot}%{_libdir}/libavcodec
rm -rf doc/.git
rm -f  doc/Makefile
rm -f  doc/texi2pod.pl
rm -f  doc/*.html.d
rm -f  doc/print_options
rm -f  doc/print_options.*
rm -f  doc/ffmpeg.1 doc/ffplay.1 doc/ffprobe.1 doc/ffserver.1
install -m 644 libavcodec/dvdata.h %{buildroot}%{_includedir}/libavcodec/
rm -f %{buildroot}%{_libdir}/*.{la,a}

%clean
[ %{buildroot} != "/" ] && rm -rf %{buildroot}

%post   -n %{libnameavcodec} -p /sbin/ldconfig
%postun -n %{libnameavcodec} -p /sbin/ldconfig

%post   -n %{libnameavdevice} -p /sbin/ldconfig
%postun -n %{libnameavdevice} -p /sbin/ldconfig

%post   -n %{libnameavformat} -p /sbin/ldconfig
%postun -n %{libnameavformat} -p /sbin/ldconfig

%post   -n %{libnameavutil} -p /sbin/ldconfig
%postun -n %{libnameavutil} -p /sbin/ldconfig

%post   -n %{libnamepostproc} -p /sbin/ldconfig
%postun -n %{libnamepostproc} -p /sbin/ldconfig

%post   -n %{libnameavfilter} -p /sbin/ldconfig
%postun -n %{libnameavfilter} -p /sbin/ldconfig

%post   -n %{libnameswscale} -p /sbin/ldconfig
%postun -n %{libnameswscale} -p /sbin/ldconfig

%post   -n %{libnameswresample} -p /sbin/ldconfig
%postun -n %{libnameswresample} -p /sbin/ldconfig

%post -n %{libnameavresample} -p /sbin/ldconfig
%postun -n %{libnameavresample} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc Changelog COPYING.* CREDITS LICENSE README doc
%{_bindir}/*
%dir %{_datadir}/ffmpeg
%{_datadir}/ffmpeg/ffprobe.xsd
%{_datadir}/ffmpeg/*.ffpreset
%{_mandir}/man1/*

%files -n %{libnameavcodec}
%defattr(-,root,root)
%{_libdir}/%{libavcodec}.so.%{majoravcodec}*

%files -n %{libnameavdevice}
%defattr(-,root,root)
%{_libdir}/%{libavdevice}.so.%{majoravdevice}*

%files -n %{libnameavformat}
%defattr(-,root,root)
%{_libdir}/%{libavformat}.so.%{majoravformat}*

%files -n %{libnameavutil}
%defattr(-,root,root)
%{_libdir}/%{libavutil}.so.%{majoravutil}*

%if %{with avfilter}
%files -n %{libnameavfilter}
%defattr(-,root,root)
%{_libdir}/%{libavfilter}.so.%{majoravfilter}*
%endif

%files -n %{libnamepostproc}
%defattr(-,root,root)
%{_libdir}/%{libpostproc}.so.%{majorpostproc}*

%files -n %{libnameswscale}
%defattr(-,root,root)
%{_libdir}/%{libswscale}.so.%{majorswscale}*

%files -n %{libnameswresample}
%defattr(-,root,root)
%{_libdir}/%{libswresample}.so.%{majorswresample}*

%files -n %{libnameavresample}
%defattr(-,root,root)
%{_libdir}/%{libavresample}.so.%{majoravresample}*

%files -n %{lib}-devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/libavcodec
%{_libdir}/pkgconfig/*.pc
%{_datadir}/ffmpeg/examples

%changelog
* Fri May 31 2013 cs@linux-administrator.com
- re-import
